/**
 * @author hanyaolong
 * @date 2019/08/12
 * @info 模型管理/模型文件管理
 */
import httputils from '@/api/scan/httpUtil'
import { Message } from 'element-ui';
const baseUrl = '/modelapi'

let api = {
    // 新建模型文件夹
    /**
     * 
     * @param {Name:string,ProjectId:string} params 
     */
    createModel(params, success) {
        let Name = params.Name;
        this.queryModel(Name,(res)=>{
            if(res.Total == 0){
                let data = {
                    Content: [params]
                };
                // 查询是否有该模型文件夹
                // 创建
                httputils.postJson(`${baseUrl}/model-folder/create`, data, success)
            }else{
                Message.error({message:'该文件夹已经存在！'});
            }
        })
    },
    //删除模型文件夹
    /**
     * 
     * @param {Id:string} params 
     */
    deleteModel(params, success) {
        let Content = [params];
        httputils.postJson(`${baseUrl}/model-folder/delete`, Content, success)
    },
    //修改模型文件夹名称
    /**
    * 
    * @param {Name:string,ProjectId:string} params 
    */
    updateModelName(params, success) {
        let Name = params.Name;
        this.queryModel(Name,(res)=>{
            if(res.Total == 0){
                let data = {
                    Content: [params]
                };
                // 更改文件夹名称
                httputils.postJson(`${baseUrl}/model-folder/update`, data, success)
            }else{
                Message.error({message:'该文件夹已经存在！'});
            }
        })
    },
    //查询模型文件夹
    /** 
     * @param Name string  注:查询多个 Name = '' 
    */
    queryModel(Name, success) {
        let data = null;
        if (Name) {
            // 单个查询
            data = {
                Filters: `Name='${Name}'`
            }
        } else {
            // 多个查询
            data = {}
        }
        return httputils.postJson(`${baseUrl}/model-folder/query`, data, success)
    },



    //以下是楼层文件接口

    // 查询模型文件夹下的所有模型文件
    queryFloor(data, success) {
        let Filters = `FolderId='${data.folderId}'`;
        if(data.FloorName){
            Filters = `FolderId='${data.folderId}';FloorName='${data.FloorName}';ProjectId='${data.ProjectId}'`;
        }
        let params = {
            Filters: Filters
        }
        return httputils.postJson(`${baseUrl}/model-floor/query`, params, success)
    },
    // 创建楼层文件
    createFloor(params, success) {
        // 判断该楼层文件是否存在
        // let Name = params.Name;
                  let data = {
                    Content: [params]
                };
        this.queryFloor(params,(res)=>{
            if(res.Total == 0){
                // let data = {
                //     Content: [params]
                // };
                let modelFile = {
                    Content:{
                       ProjectId:params.ProjectId,
                       FolderId:params.folderId,
                       FloorName:params.FloorName
                    }
                }
                // 创建模型文件
                this.createModelFile(modelFile,(res)=>{
                // 创建楼层文件(传入模型文件id)
                console.log('/创建楼层文件(传入模型文件id)',res)
                //  httputils.postJson(`${baseUrl}/model-floor/create`, data, success)
                })
            
            }else{
                Message.error({message:'该楼层文件已经存在，请选择其他楼层！'});
            }
        })
    },
    // 删除楼层文件
    deleteFloor(data) {
        return httputils.postJson(`${baseUrl}/model-floor/delete`, data)
    },
    //编辑楼层文件得名字
    updateFloorName(data) {
        return httputils.postJson(`${baseUrl}/model-floor/update`, data)
    },


    //一下是楼层文件接口

    // 创建楼层文件
    createModelFile(data,success) {
        return httputils.postJson(`${baseUrl}/model-floor/create`, data,success)
    },
    //删除模型文件
    deleteModelFile(data) {
        return httputils.postJson(`${baseUrl}/model-file/delete`, data)
    },
    // 上传模型文件
    uploadModelFile(data) {
        return httputils.postJson(`${baseUrl}/model-file/upload`, data)
    },
    //更新楼层文件
    upDateModelFile() {
        return httputils.postJson(`${baseUrl}/model-floor/update`, data)
    },
    //查询模型文件 
    queryModelFile(FloorModelId,success) {
        let params = {
            Distince:true,
            Filters : `FloorModelId='${FloorModelId}'`
        }
        return httputils.postJson(`${baseUrl}/model-floor/query`, params,success)
    }

}
export default api